<?php

/**
 * Regroupe les fonctions de gestion d'une session utilisateur.
 * @package default
 * @todo  RAS
 */

/**
 * Démarre ou poursuit une session.                     
 *
 * @return void
 */
function initSession() {
    session_start();
    // Tableau des erreurs
    // initialisé lors du démarrage de la session
    // et stocké dans la session
    $tabErreurs = array();
    setTabErreurs($tabErreurs);
}

/**
 * Fournit l'id du visiteur connecté.                     
 *
 * Retourne l'id du visiteur connecté, une chaîne vide si pas de visiteur connecté.
 * @return string id du visiteur connecté
 */
function obtenirIdUserConnecte() {
    $ident = "";
    if (isset($_SESSION["loginUser"])) {
        $ident = (isset($_SESSION["idUser"])) ? $_SESSION["idUser"] : '';
    }
    return $ident;
}

/**
 * Conserve en variables session les informations du visiteur connecté
 * 
 * Conserve en variables session l'id $id et le login $login du visiteur connecté
 * @param string id du visiteur
 * @param string login du visiteur
 * @return void    
 */
function affecterInfosConnecte($id, $login) {
    $_SESSION["idUser"] = $id;
    $_SESSION["loginUser"] = $login;
}

/**
 * Déconnecte le visiteur qui s'est identifié sur le site.                     
 *
 * @return void
 */
function deconnecterVisiteur() {
    unset($_SESSION["idUser"]);
    unset($_SESSION["loginUser"]);
}

/**
 * Vérifie si un visiteur s'est connecté sur le site.                     
 *
 * Retourne true si un visiteur s'est identifié sur le site, false sinon. 
 * @return boolean échec ou succès
 */
function estVisiteurConnecte() {
    // actuellement il n'y a que les visiteurs qui se connectent
    return isset($_SESSION["loginUser"]);
}
/**
 * Stocke le tableau des erreurs dans la session
 * @param type $tabErreurs : Tableau des erreurs
 */
function setTabErreurs($tabErreurs) {
    $_SESSION["tabErreurs"] = $tabErreurs;
}

/**
 * Récupère le tableau des erreurs
 * @return tableau des erreurs
 */
function getTabErreurs() {
    return $_SESSION["tabErreurs"];
}

?>